// (c) 2006 Philipp Klaus Krause philipp@colecovision.eu

#include "analyzer.h"

#include <limits.h>
#include <stdio.h>

void analyze_stream(FILE *stream, unsigned long count[UCHAR_MAX + 1])
{
	int character;
	while((character = getc(stream)) != EOF)
		count[character]++;
}

void analyze_files(char *filenames[], unsigned long count[UCHAR_MAX + 1])
{
	unsigned char i;
	for(i = UCHAR_MAX; i >= 1; i--)
		count[i] = 0;
	count[0] = 0;

	for(i = 0; filenames[i]; i++)
	{
		FILE *file;
		if(!(file = fopen(filenames[i], "rb")))
		{
			fprintf(stderr, "Could not open file: %s\n", filenames[i]);
			fprintf(stderr, "Ignoring this file for analysis.\n");
		}

		analyze_stream(file, count);

		fclose(file);
	}
}
