// (c) 2006 Philipp Klaus Krause philipp@colecovision.eu

#include "analyzer.h"

#include <limits.h>
#include <stdio.h>

unsigned long count[UCHAR_MAX + 1];

int main(int argc, char *argv[])
{
	FILE* codefile;
	
	if(!(codefile = fopen("rle_escape.h", "w")))
	{
		fprintf(stderr, "Could not open rle_escape.h for output.\n");
		return(-1);
	}

	analyze_files(argv + 1, count);
	
	unsigned char i;
	unsigned char least_common = 0;
	unsigned long int least_common_count = count[0];
	for(i = UCHAR_MAX; i >= 1; i--)
		if(count[i] < least_common_count)
		{
			least_common = i;
			least_common_count = count[i];
		}

	fprintf(codefile, "//rle escape byte generated by ColecoVision rle_analyzer.\n#include <stdint.h>\n");
	fprintf(codefile, "#define RLE_ESCAPE (const uint8_t)(%u)\n", least_common);
	fclose(codefile);

	return(0);
}

